import getopt
import os, subprocess
import sys
import pp

def runcmd(command):
    print "executing command: " + command 
    subproc = subprocess.Popen(("python " + command).split(" "), stdout=subprocess.PIPE)
    output = subproc.communicate()[0].split()
    #print output

def usage():
    """
    Function that print usages informations for this program.
    """
    print """
Usage: exec.py <script_file> [<script_files>]
Options:
    -n, --nproc              Number of process, jobs (default 1)
    -h, --help               Print this help message
"""

if __name__ == "__main__":
    try:
        opts, args = getopt.getopt(sys.argv[1:], 'n:h', ['nproc','help'])
    except getopt.error, err:
        usage()
        sys.exit(2)
    
    njobs = 1
    
    for o, a in opts:
        if o in ('-h', '--help'):
            usage()
            sys.exit(0)
        elif o in ('-n', '--nproc'):
            njobs = int(a)
        else:
            assert False, "unhandled option"
    
    scripts = sys.argv[1:]
    
    if (len(scripts) == 0):
        usage()
        sys.exit(2)
        
    job_server = pp.Server()
    ncpu=job_server.get_ncpus()
    job_server.set_ncpus(ncpu)
    jobs = []

    for i, script_filename in enumerate(scripts):
        script_file = open(script_filename)
        script_commands = script_file.read().split("\n")
        for i, command in enumerate(script_commands):            
            jobs.append(job_server.submit(runcmd,(command,),(),("os","subprocess",)))
            job_server.print_stats()
            if (i + 1) % njobs:
                job_server.wait()
            print "jobs: "
            print [job() for job in jobs]