import numpy as np
import cmath as math
import matplotlib.pyplot as plt
from matplotlib.backends.backend_pdf import PdfPages
from pylab import *
import matplotlib.cm as cm
import string as s
import hierarquico
import scikits.learn.linear_model as lm

def read(fileInput):
        f = open(fileInput, 'r')

         # Faz a leitura do arquivo e salva em "texto"
        texto = []
        for line in f:   ## iterates over the lines of the file
                texto.append(line)
        f.close()

        # A primeira linha contem os labels. Desconsideramos as 3 primeiras palavras ("ID", "NT" e "EXP")
        histonas = texto.pop(0).split('\t')[3:]
        histonas[-1] = histonas[-1][:-1] #Removemos o ultimo caractere da ultima histona ('\n')

        ID = []
        NT = []
        expressao = []
        matrizHistonas = []
        contadorLinhas = 0
        for linha in texto:
                palavrasDaLinha = linha.split('\t')
                ID.append(palavrasDaLinha[0])
                NT.append(palavrasDaLinha[1])
                expressao.append(s.atof(palavrasDaLinha[2]))
                matrizHistonas.append(palavrasDaLinha[3:])
		for i in range(len(matrizHistonas[0])):
                        matrizHistonas[contadorLinhas][i] = s.atof(matrizHistonas[contadorLinhas][i])#transforma a string em numero
                contadorLinhas = contadorLinhas + 1

        return ID, NT, expressao, matrizHistonas, histonas

def ordemY(expressaoY):
        tuplaY_indice = []
        for i in range(len(expressaoY)):
                tuplaY_indice.append((expressaoY[i], i))
        tuplaY_indice.sort(reverse = False)
        return [ tupla[1] for tupla in tuplaY_indice ]        

def ordenarDados(Y, X, previous, ordem):
        Y_ordenado = []
        X_ordenado = []
        previousOrdenado = []
        for j in range(len(previous)):
            previousOrdenado.append([])
        for i in ordem:
                Y_ordenado.append(Y[i])
                X_ordenado.append(X[i])
                for j in range(len(previous)):
                    #print i, ' == ', len(previous[0]), ' -> ', i == len(previous[0])
                    if i == len(previous[0]):
                        previousOrdenado[j].append(1.0/len(previous))#------------------------------------------------------------------------
                    else:
                        previousOrdenado[j].append(math.exp(previous[j][i]))
        return Y_ordenado, X_ordenado, previousOrdenado

def ordenarDadosSimples(Y, X, ordem):
        Y_ordenado = []
        X_ordenado = []
        previousOrdenado = []
        for i in ordem:
                Y_ordenado.append(Y[i])
                X_ordenado.append(X[i])
        return Y_ordenado, X_ordenado, previousOrdenado

#Recebe a lista de saida ordenada "Y", uma lista de valores de uma histona ordendada e o tamanho da janela para calculo da media
def plotarGraficoHistonaY(Y, histonas, previous, nomeHistonas, listaMedias, matrizRegressao, ordemHistonas, janela, quantidade, outputPathPng, outputPathPdf):
        fig = plt.figure(figsize=(8, 6))
        colors = ['r', 'y', 'c', 'm', 'k', 'b', 'g']
        figuras = []#Guardara o path de cada grafico plotado para que o mixtureTools possa referencia-las no html
        
        iteracoes = len(histonas[0]) + janela - 1
        
        #for i in range(len(previous[0])):
            #for j in range(len(previous)):
                #print '\tORIG: (', j, ',', i, ') = ', previous[j][i]
        
        #Grafico com as probabilidades a priori
        #predicted = []
        #for k in range(min(quantidade, len(ordemHistonas))):
            #predicted.append([])
            #for i in range(len(Y)):#O tamanho de previous eh 1 unidade menor (bug?)
                #weightedSum = 0
                #for j in range(len(previous)):
                    #weigh = math.exp(previous[j][i])#Calcula a probabilidade (a partir da exponencial)
                    #Previsao = b0 + SUMi(Peso(i) * X*Bi):
                    #weightedSum = weightedSum + weigh * (histonas[ordemHistonas[k]][i]*matrizRegressao[j][ordemHistonas[k]] + listaMedias[j])
                #predicted[k].append(weightedSum)

        predictedMedia = []
        for i in range(len(previous)):
            predictedMedia.append([])
            mediaY_predicted = 0.0
            for j in range(iteracoes):
                    if j < janela:
                        mediaY_predicted = mediaY_predicted + previous[i][j]
                    elif j < (iteracoes - janela):
                        mediaY_predicted = mediaY_predicted - previous[i][j - janela] + previous[i][j]
                    else:
                        mediaY_predicted = mediaY_predicted - previous[i][j - janela]
                    predictedMedia[i].append(mediaY_predicted/janela)
            #print 'pred', predictedMedia[i]
	aux=np.array(predictedMedia)
	#print 'aqui', aux[:,5000:5300]
        #for i in range(len(predictedMedia[0])):
            #for j in range(len(predictedMedia)):
                #print '(', j, ',', i, ') = ', predictedMedia[j][i]
                
        iteracoes = len(histonas[0]) + janela - 1
        
        previsao = []
        
        for j in range(min(quantidade, len(ordemHistonas))):
                #print j, 'j'
                mediaX = 0
                mediaY = 0
                mediaY_predicted = 0
                listaMediasX = []
                listaMediasY = []
                listaMediasY_predicted = []
                for i in range(iteracoes):
                        if i < janela:
                                mediaX = mediaX + histonas[ordemHistonas[j]][i]#Obtem a media dos "i" primeiros valores
                                mediaY = mediaY + Y[i]
                        elif i < (iteracoes - janela):
                                mediaX = mediaX - histonas[ordemHistonas[j]][i - janela] + histonas[ordemHistonas[j]][i]
                                mediaY = mediaY - Y[i - janela] + Y[i]
                        else:
                                mediaX = mediaX - histonas[ordemHistonas[j]][i - janela]
                                mediaY = mediaY - Y[i - janela]
                        listaMediasX.append(mediaX/janela)
                        listaMediasY.append(mediaY/janela)
                plt.subplot(1, 1, 1)
                menorY = min(listaMediasY[janela:(-janela)])
                indexMenorY = np.argmin(listaMediasY[janela:(-janela)])
                maiorY = max(listaMediasY[janela:(-janela)])
                indexMaiorY = np.argmax(listaMediasY[janela:(-janela)])
                #menorX = min(listaMediasX[janela:(-janela)])
                #maiorX = max(listaMediasX[janela:(-janela)])
                menorX = listaMediasX[janela+indexMenorY]
                maiorX = listaMediasX[janela+indexMaiorY]
                
                
                previsao.append([0] * iteracoes)
                
                #for i in range(iteracoes):#Para cada dado da entrada (com a "suavizacao das janelas/medias")
                    #weightedSum = 0
                    #for k in range(len(previous)):#Para cada componente do cluster
                        #print 'i = ', i, '\tk = ', k, '\t predicted = ', predictedMedia[k][i]
                        #weightedSum = weightedSum + predictedMedia[k][i]*(listaMediasX[i]*matrizRegressao[k][ordemHistonas[j]] + listaMedias[k])
                    #previsao[j][i] = previsao[j][i] + weightedSum
                    
                
                plt.plot(listaMediasY[janela:(-janela)], listaMediasX[janela:(-janela)])
                
                #previsao[janela:(-janela)], listaMediasX[janela:(-janela)])
                
                mediaY = np.mean(Y)
		predictedMedia = np.array(predictedMedia)
                plt.hold(True)
                for i in range(len(listaMedias)):
                        #filtroX = []
                        #filtroY = []
                        #filtroPrevious = []
                        #for k in range(len(Y)):
                            #if previous[i][k] > 1.0/len(listaMedias):
                                #filtroX.append(histonas[ordemHistonas[j]][k])
                                #filtroY.append(Y[k])
                                #filtroPrevious.append(previous[i][k])
                        #mediaYGlobal = np.mean(np.multiply(Y,previous[i]))#np.mean(filtroY)
                        Yposteriori = np.multiply(listaMediasY[janela:(-janela)],predictedMedia[i,janela:(-janela)])			
                        mediaYaux=np.mean(Yposteriori)
                        #Yposteriori-=mediaYaux
			
                        Xposteriori = np.multiply(listaMediasX[janela:(-janela)], predictedMedia[i,janela:(-janela)])

##                        #angular = np.dot(Yposteriori, Xposteriori)/np.dot(Xposteriori, Xposteriori)
##                        #linear = np.mean(Yposteriori - angular*Xposteriori) + mediaYaux

			model = lm.LinearRegression()
			model.fit(np.transpose( [Xposteriori]),Yposteriori)
			#print model.intercept_,model.coef_
			angular = model.coef_
                        linear = model.intercept_

			#print Yposteriori
			#print Xposteriori
			#print predictedMedia[i,100:110]
			 
                        #print  'HISTONA: ', nomeHistonas[ordemHistonas[j]], '\tLINEAR: ', linear, '\n\tANGULAR: ', angular, menorX, maiorX, menorY, maiorY
                        #print 'Y =[', menorY,',',maiorY, '] \tX = [', (menorY - linear)/angular, ',', (maiorY - linear)/angular,']'
                        #mediaXHistona = np.mean(histonas[ordemHistonas[j]])#np.mean(filtroX)
                        #b0 = mediaYGlobal - mediaXHistona*matrizRegressao[i][ordemHistonas[j]]
                        #print nomeHistonas[ordemHistonas[j]], ' ', i, ' ', 'mediaYGlobal: ', mediaYGlobal, '   b0: ', b0, '  TamanhoFiltro', len(filtroX)
                        #plt.plot([menorY, maiorY], [(menorY - linear)/angular, (maiorY - linear)/angular], colors[i%len(colors)])
			#listaMediasYAux = np.array(listaMediasY[janela:-janela])
                        #ordemAux = ordemY(listaMediasYAux)
			
		        #plt.plot(listaMediasYAux[ordemAux],Xposteriori[ordemAux])
			#plt.plot(listaMediasYAux[ordemAux],predictedMedia[i,ordemAux])
		
##                        #plt.plot([menorY, maiorY], [(menorY - b0)/matrizRegressao[i][ordemHistonas[j]], (maiorY - b0)/matrizRegressao[i][ordemHistonas[j]]], colors[i%len(colors)])
##                        #Melhor: plt.plot([menorY, maiorY], [menorX*matrizRegressao[i][ordemHistonas[j]] - b0, maiorX*matrizRegressao[i][ordemHistonas[j]] - b0], colors[i%len(colors)])
##                        #plt.plot([b0, 0], [0, -b0/matrizRegressao[i][ordemHistonas[j]]], colors[i%len(colors)])
##                        #plt.plot([menorX*matrizRegressao[i][ordemHistonas[j]] + listaMedias[i], maiorX*matrizRegressao[i][ordemHistonas[j]] + listaMedias[i]], [menorX, maiorX], colors[i%len(colors)])
			
                plt.hold(False)
                        
                #plt.axis('tight')
                plt.ylim(np.min(listaMediasX[janela:(-janela)]), np.max(listaMediasX[janela:(-janela)]))
		#plt.ylim(0,1.5)
                plt.xlim(menorY, maiorY)
                plt.xlabel('Expression')
                plt.ylabel(nomeHistonas[ordemHistonas[j]])
                
                #Codigo da legenda
                s = ['Global']
                for i in range(len(listaMedias)):
                        s.append('Model %d' %(i+1))
                #print '\tA LEGENDA ESTA ASSIM: ', s
                #plt.legend(s, bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)

		#print j, ordemHistonas, nomeHistonas

                plt.savefig(outputPathPng + str(len(listaMedias)) + "_expressionComplete_" + nomeHistonas[ordemHistonas[j]] + ".png")
                plt.savefig(outputPathPdf + str(len(listaMedias)) + "_expressionComplete_" + nomeHistonas[ordemHistonas[j]] + ".pdf")
                figuras.append("png/" + str(len(listaMedias)) + "_expressionComplete_" + nomeHistonas[ordemHistonas[j]] + ".png")
        regression = []
        for i in range(iteracoes):
                regression.append(0)
                for j in range(min(quantidade, len(ordemHistonas))):
                    regression[i] = regression[i] + previsao[j][i]
        fig = plt.figure(figsize=(8, 6))
        #plt.plot(listaMediasY[janela:(-janela)], listaMediasX[janela:(-janela)], regression[janela:(-janela)], listaMediasX[janela:(-janela)])
        plt.plot(listaMediasY[janela:(-janela)], regression[janela:(-janela)], listaMediasY[janela:(-janela)], listaMediasY[janela:(-janela)])
        plt.axis('tight')
        plt.savefig(outputPathPng + "regressionComplete" + ".png")
        plt.savefig(outputPathPdf + "regressionComplete" + ".pdf")
                
                #for i in range(len(Y)-janela):
                    #print 'Y = ', Y[i], '\tPREVIOUS =' ,previsao[i+janela]
        return figuras

def plotarGraficoHistonaYSimples(Y, histonas, nomeHistonas, ordemHistonas, janela, quantidade, outputPathPng, outputPathPdf):
        colors = ['r', 'y', 'g', 'c', 'b', 'm', 'k']
        figuras = []#Guardara o path de cada grafico plotado para que o mixtureTools possa referencia-las no html
        
        for j in range(min(quantidade, len(ordemHistonas))):
                #print j, 'j'
                fig = plt.figure(figsize=(8, 6))
                mediaX = 0
                mediaY = 0
                mediaY_predicted = 0
                listaMediasX = []
                listaMediasY = []
                iteracoes = len(histonas[0]) + janela - 1
                
                for i in range(iteracoes):
                        if i < janela:
                                mediaX = mediaX + histonas[ordemHistonas[j]][i]#Obtem a media dos "i" primeiros valores
                                mediaY = mediaY + Y[i]
                        elif i < (iteracoes - janela):
                                mediaX = mediaX - histonas[ordemHistonas[j]][i - janela] + histonas[ordemHistonas[j]][i]
                                mediaY = mediaY - Y[i - janela] + Y[i]
                        else:
                                mediaX = mediaX - histonas[ordemHistonas[j]][i - janela]
                                mediaY = mediaY - Y[i - janela]
                        listaMediasX.append(mediaX/janela)
                        listaMediasY.append(mediaY/janela)
                plt.subplot(1, 1, 1)
                menorY = min(listaMediasY[janela:(-janela)])/janela
                maiorY = max(listaMediasY[janela:(-janela)])/janela
                menorX = min(listaMediasX[janela:(-janela)])
                maiorX = max(listaMediasX[janela:(-janela)])
                
                plt.plot(listaMediasY[janela:(-janela)], listaMediasX[janela:(-janela)])

                plt.axis('tight')
                plt.xlabel('Expression')
		#print nomeHistonas[ordemHistonas[j]]
                plt.ylabel(nomeHistonas[ordemHistonas[j]])
                
                plt.savefig(outputPathPng + "expression_" + nomeHistonas[ordemHistonas[j]] + ".png")
                plt.savefig(outputPathPdf + "expression_" + nomeHistonas[ordemHistonas[j]] + ".pdf")
                figuras.append("png/expression_" + nomeHistonas[ordemHistonas[j]] + ".png")
                
        return figuras
                
def pintar(fileInput, matrizRegressao, listaMedias, previous, header, outputPathPng, outputPathPdf, top, filtro):
        ID, NT, Y, X, nomeHistonas = read(fileInput)
        #print '\tTAMANHO DE PREVIOUS: ', len(previous)
        #print '\tTAMANHO DE PREVIOUS[0]', len(previous[0])
        #print '\tTAMANHO DE PREVIOUS[0][0:5]', previous[0][:5]
        #print '\tTAMANHO DE PREVIOUS[1]', len(previous[1])
        #print '\tTAMANHO DE PREVIOUS[1][0:5]', previous[1][:5]
        ordemExpressao = ordemY(Y)
        Y_ordenado, X_ordenado, previousOrdenado = ordenarDados(Y, X, previous, ordemExpressao)
        X_ordenado_transposto = np.transpose(X_ordenado)
        #print X_ordenado[0], X_ordenado[len(X)-1]
        #ordemImportancia_X = hierarquico.filtrarMaiores(X_ordenado_transposto, len(X_ordenado_transposto), False)
        #ordemImportancia_X = hierarquico.filtrarMaiores(X_ordenado_transposto, top, False)
        #print 'ordemImportancia_X:', ordemImportancia_X
        #plotarGraficoHistonaY(Y_ordenado, X_ordenado_transposto, previousOrdenado, nomeHistonas, listaMedias, matrizRegressao, ordemImportancia_X, 50, 10, outputPathPng, outputPathPdf)
        return plotarGraficoHistonaY(Y_ordenado, X_ordenado_transposto, previousOrdenado, header, listaMedias, matrizRegressao, filtro, 50, top, outputPathPng, outputPathPdf)

def pintarSimples(filename, outputPathPng, outputPathPdf):
        ID, NT, Y, X, nomeHistonas = read(filename)
        ordemExpressao = ordemY(Y)
        Y_ordenado, X_ordenado, previousOrdenado = ordenarDadosSimples(Y, X, ordemExpressao)
        X_ordenado_transposto = np.transpose(X_ordenado)
        ordemImportancia_X = hierarquico.filtrarMaiores(X_ordenado_transposto, len(X_ordenado_transposto), False)
        return plotarGraficoHistonaYSimples(Y_ordenado, X_ordenado_transposto, nomeHistonas, ordemImportancia_X, 50, 10, outputPathPng, outputPathPdf)


def main():
        if len(sys.argv) == 2:
            ID, NT, Y, X, nomeHistonas = read(sys.argv[1])
            ordemExpressao = ordemY(Y)
            Y_ordenado, X_ordenado, previousOrdenado = ordenarDadosSimples(Y, X, ordemExpressao)
            X_ordenado_transposto = np.transpose(X_ordenado)
            ordemImportancia_X = hierarquico.filtrarMaiores(X_ordenado_transposto, len(X_ordenado_transposto), False)
            print plotarGraficoHistonaYSimples(Y_ordenado, X_ordenado_transposto, nomeHistonas, ordemImportancia_X, 50, 10, "res/png/", "res/pdf/")
        else:
                print 'ERRO NA QUANTIDADE DE PARAMETROS'


if __name__ == '__main__':
  main()

