import mixture
import numpy
import random
import copy
import math
import scipy.stats


class GausianLaplacePriorDistribution(mixture.PriorDistribution):
    """ Laplace prior distribution """

    def __init__(self, m, c):
        self.m = m 
	self.c = c

    def pdf(self, models):
        prior = 0   
        for i,model in enumerate(models):
          prior +=  numpy.log(scipy.stats.laplace.pdf(model.mean,loc=self.m,scale=self.c*model.sigma^2))
        return prior


    def isValid(self,x):
        if isinstance(x, GausianLaplacePriorDistribution):
            return True
        else:
            return False
        
    def __copy__(self):        
        return GausianLaplacePriorDistribution(self.m,self.c)
    
    def __str__(self):
        return "GausianLaplacePriorDistribution: "+str(self.m)+" "+str(self.c)      


    def updateHyperparameters(self, dists, posterior, data): 
        """
        Update the hyperparameters in an empirical Bayes fashion.
        
        @param dists: list of ProbabilityDistribution objects
        @param posterior: numpy matrix of component membership posteriors
        @param data: DataSet object
        """
        pass

    def posterior(self,m,x):  
        raise NotImplementedError, "Needs implementation"

    def marginal(self,x):
        raise NotImplementedError, "Needs implementation"

    def mapMStep(self, dist, posterior, data, mix_pi=None, dist_ind = None):
    
        """ Map estimates of Gausian Laplace
        """

	if isinstance(data, mixture.DataSet):
		dt = data.internalData
	elif isinstance(data,numpy.ndarray):
		dt = data
	else:
		raise TypeError, "Unknown/Invalid input to MStep."

	mu = numpy.dot(posterior,data)/posterior.sum()

	if mu - 1/(self.c*dist.sigma^2) > self.m:
          dist.mean=mu-1/(self.c*dist.sigma^2)
	elif mu + 1/(self.c*dist.sigma^2) < self.m:
          dist.mean=mu+1/(self.c*dist.sigma^2)
	else: 
	  dist.mean=self.m
    
        dist.sigma = math.sqrt(numpy.dot(posterior, (x - new_mu)**2  - numpy.abs(dist.mean - self.m)/self.c ) / post_sum)	
